#ifndef __COMPILER_HPP__
#define __COMPILER_HPP__

///////////////////////////////////////////////////////////////////////////////
// Autodetect compiler settings for Win32
///////////////////////////////////////////////////////////////////////////////
# if defined(_WIN32)
#   if defined(_MSC_VER)
#     define DO_MSVC    1
#     define DO_WIN32   1
#     define CPUSTRING  "Win32-x86"
#     pragma warning(disable:4097)    // typedef synonym for class
#     pragma warning(disable:4100)    // unrefrenced formal parameter
#     pragma warning(disable:4514)    // unrefrenced inline function has been removed
#     pragma warning(disable:4663)    // changes made template specialization (c++ language)
#     pragma warning(disable:4710)    // function could not be inlined
#     pragma warning(disable:4711)    // function selected for automatic inline expansion
#     pragma warning(disable:4702)    // line contains unreachable code
#     pragma inline_recursion( on )   // compiler should try to inline code
#     pragma inline_depth( 255 )      // inline recursion depth setting
#   elif defined(__BORLANDC__)
#     define DO_BCC     1
#     define DO_WIN32   1
#     define CPUSTRING	"Win32-x86"
#   elif defined(__GNUC__)
#     define DO_GCC     1
#     define DO_WIN32   1
#     define CPUSTRING  "Win32-x86"
#   elif defined(__MWERKS__)			
#     define DO_MWERKS  1
#     define DO_WIN32	  1
#     define CPUSTRING  "Win32-x86"
#   elif defined(__ICL)
#     define DO_INTEL   1
#     define DO_WIN32   1
#     define CPUSTRING  "Win32-x86"
#   endif
# endif

///////////////////////////////////////////////////////////////////////////////
// Autodetect compiler settings for MacOS X
///////////////////////////////////////////////////////////////////////////////
# if defined(__MACH__) && defined(__APPLE__)
#   ifdef __ppc__
#     define DO_MACOSX  1
#     define CPUSTRING  "MacOSX-ppc"
#   elif defined __i386__
#     define DO_MACOSX  1
#     define CPUSTRING  "MacOSX-i386"
#   else
#     define DO_MACOSX  1
#     define CPUSTRING  "MacOSX-other"
#   endif
# endif

///////////////////////////////////////////////////////////////////////////////
// Autodetect compiler settings for MacOS
///////////////////////////////////////////////////////////////////////////////
# if defined(__MACOS__)
#   define DO_MACOS     1
#   define CPUSTRING    "MacOS-ppc"
# endif

///////////////////////////////////////////////////////////////////////////////
// Autodetect compiler settings for Linux
///////////////////////////////////////////////////////////////////////////////
# if defined(__linux__)
#   ifdef __i386__
#     define DO_LINUX   1
#     define CPUSTRING  "Linux-i386"
#   elif defined __axp__
#     define DO_LINUX   1
#     define CPUSTRING  "Linux-alpha"
#   else
#     define DO_LINUX   1
#     define CPUSTRING  "Linux-other"
#   endif
# endif


#endif